load rocket-mixed.mat
build5
minfo(sysx)
disp ('Perform an H-inf synthesis without scalings')
[k1, clp1] = hinfsyn (sysx, 1, 1, 2, 3, 0.001);

disp ('Compute the mu-norm')
[bnds1, dvec1, sens1] = mu (frsp (clp1, w), blk);
disp (pkvnorm (sel (bnds1, 1, 1)))

disp ('Find scalings in state-space form')
dL1 = muftbtch ('first', dvec1, sens1, blk, 1, 1, [0.26 0.1 3 3]);
dL1 = sysbal (dL1);
% order [3 3 -]

disp ('Scale the system') 
mux1 = mmult (dL1, sysx, minv(dL1));
mux1 = cf2sys (sncfbal (mux1));
minfo(mux1)
minfo(sysx)

disp ('Perform the second H-inf synthesis on the scaled system')
[k2, clp2] = hinfsyn (mux1, 1, 1, 0.8, 1.2, 0.001);


disp ('Compute the mu-norm')
[bnds2, dvec2, sens2] = mu (frsp(clp2, w), blk);
disp (pkvnorm (sel (bnds2, 1, 1)))

% bnds2r = mu (frsp(clp2,w), blkr);
% disp (pkvnorm (sel (bnds2r, 1, 1)))

disp ('Find scalings in state-space form')
dL2 = muftbtch (dL1, dvec2, sens2, blk, 1, 1, [0.26 0.1 3 3]);
dL2 = sysbal (dL2);
% order [3 3 -]

disp ('Scale the system') 
mux2 = mmult (dL2, sysx, minv(dL2));
mux2 = cf2sys (sncfbal (mux2));

disp ('Perform the third H-inf synthesis on the scaled system')
[k3, clp3] = hinfsyn (mux2, 1, 1, 0.9, 1.1, 0.001);

disp ('Compute the mu-norm')
[bnds3, dvec3, sens3] = mu (frsp(clp3,w), blk);
disp (pkvnorm (sel (bnds3, 1, 1)))

disp ('Find scalings in state-space form')
dL3 = muftbtch (dL2, dvec3, sens3, blk, 1, 1, [0.26 0.1 3 3]);
dL3 = sysbal (dL3);
% order [3 3 -]

disp ('Scale the system') 
mux3 = mmult (dL3, sysx, minv(dL3));
mux3 = cf2sys (sncfbal (mux3));

disp ('Perform the fourth H-inf synthesis on the scaled system')
[k4, clp4] = hinfsyn (mux3, 1, 1, 0.9, 1.1, 0.001);
[bnds4, dvec4, sens4] = mu (frsp(clp4,w), blk);
disp (pkvnorm (sel (bnds4, 1, 1)))

disp ('try to reduce the order of the model')
disp ('first, remove fast states')
% model reduction, remove fast pole
[fast, slow] = sdecomp (k4, -1000);
slow = madd (slow, vunpck (frsp (fast, 0)));
[bal, sv] = sysbal (slow);
disp ('reduced order controller')
disp (sv')

disp ('next, use model reduction using sysbal')
k4r = sysbal (slow, 0.07);
minfo(k4r)
bnds4r = mu (frsp (starp (sysx, k4r), w), blk);
disp (pkvnorm (sel (bnds4r, 1, 1)))

disp ('next, use model reduction using sncfbal')
% sncfbal
k4c = cf2sys (sncfbal (slow, 0.01));
minfo(k4c)
bnds4c = mu (frsp (starp (sysx, k4c), w), blk);
disp (pkvnorm (sel (bnds4c, 1, 1)))

disp ('next, use model reduction using sysbal')
k4r4 = sysbal (slow, 0.3);
minfo(k4r4)
bnds4r4 = mu (frsp (starp (sysx, k4r4), w), blk);

disp (pkvnorm (sel (bnds4r4, 1, 1)))
